﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;
using System.Drawing.Drawing2D;

namespace howto_fill_contain
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private const float TINY = 0.0001f;
        private List<PointF> Points = new List<PointF>();
        private bool Drawing = false;

        private List<PointF> NonIntersecting = null;

        // Make a test polygon.
        private void Form1_Load(object sender, EventArgs e)
        {
            MakeStar();
        }

        private void MakeStar()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(144, 15));
            Points.Add(new PointF(52, 178));
            Points.Add(new PointF(216, 90));
            Points.Add(new PointF(59, 49));
            Points.Add(new PointF(145, 175));
            picCanvas.Refresh();
        }

        private void MakeShape2()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(50, 60));
            Points.Add(new PointF(200, 10));
            Points.Add(new PointF(90, 180));
            Points.Add(new PointF(230, 100));
            Points.Add(new PointF(120, 60));
            Points.Add(new PointF(170, 190));
            picCanvas.Refresh();
        }

        private void MakeShape3()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(90, 38));
            Points.Add(new PointF(205, 32));
            Points.Add(new PointF(62, 153));
            Points.Add(new PointF(219, 143));
            Points.Add(new PointF(65, 90));
            Points.Add(new PointF(143, 187));
            Points.Add(new PointF(218, 96));
            picCanvas.Refresh();
        }
        
        private void MakeShape4()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(139, 24));
            Points.Add(new PointF(47, 107));
            Points.Add(new PointF(231, 79));
            Points.Add(new PointF(119, 179));
            picCanvas.Refresh();
        }

        private void MakeShape5()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(50, 100));
            Points.Add(new PointF(130, 30));
            Points.Add(new PointF(230, 100));
            Points.Add(new PointF(130, 160));
            Points.Add(new PointF(130, 100));
            Points.Add(new PointF(130, 30));
            Points.Add(new PointF(130, 100));
            Points.Add(new PointF(230, 100));
            Points.Add(new PointF(130, 100));
            Points.Add(new PointF(50, 100));
            Points.Add(new PointF(130, 160));
            picCanvas.Refresh();
        }

        private void MakeShape6()
        {
            PointF center = new PointF(130, 110);
            Points = new List<PointF>();
            Points.Add(new PointF(101, 31));
            Points.Add(new PointF(194, 37));
            Points.Add(center);
            Points.Add(new PointF(215, 70));
            Points.Add(new PointF(206, 162));
            Points.Add(center);
            Points.Add(new PointF(160, 175));
            Points.Add(new PointF(78, 174));
            Points.Add(center);
            Points.Add(new PointF(64, 143));
            Points.Add(new PointF(42, 74));
            Points.Add(center);
            Points.Add(new PointF(63, 57));
            Points.Add(new PointF(95, 41));
            Points.Add(center);
            picCanvas.Refresh();
        }

        private void MakeShape7()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(20, 20));
            Points.Add(new PointF(210, 50));
            Points.Add(new PointF(200, 80));
            Points.Add(new PointF(20, 20));
            Points.Add(new PointF(150, 150));
            Points.Add(new PointF(110, 160));
            picCanvas.Refresh();
        }

        private void MakeShape8()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(48, 40));
            Points.Add(new PointF(110, 40));
            Points.Add(new PointF(110, 100));
            Points.Add(new PointF(160, 100));
            Points.Add(new PointF(160, 50));
            Points.Add(new PointF(226, 114));
            Points.Add(new PointF(160, 160));
            Points.Add(new PointF(160, 100));
            Points.Add(new PointF(110, 100));
            Points.Add(new PointF(110, 150));
            Points.Add(new PointF(48, 150));
            picCanvas.Refresh();
        }

        private void MakeShape9()
        {
            Points = new List<PointF>();
            Points.Add(new PointF(50, 40));
            Points.Add(new PointF(90, 40));
            Points.Add(new PointF(90, 100));
            Points.Add(new PointF(150, 100));
            Points.Add(new PointF(150, 50));
            Points.Add(new PointF(226, 114));
            Points.Add(new PointF(170, 160));
            Points.Add(new PointF(170, 100));
            Points.Add(new PointF(110, 100));
            Points.Add(new PointF(110, 150));
            Points.Add(new PointF(50, 150));
            picCanvas.Refresh();
        }

        private void radFill_Click(object sender, EventArgs e)
        {
            picCanvas.Refresh();
        }

        private void picCanvas_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
            e.Graphics.Clear(picCanvas.BackColor);

            // See if we are drawing a new polygon.
            if (Drawing)
            {
                // Draw the polygon so far.
                if (Points.Count > 1)
                    e.Graphics.DrawLines(Pens.Blue, Points.ToArray());
                DrawLineArrows(e.Graphics, Pens.Blue, Points, Points.Count - 1);
            }
            else
            {
                // Draw the finished polygon.
                if (Points.Count > 2)
                {
                    // Fill the polygon appropriately.
                    if (radContain.Checked)
                    {
                        // Find and fill the non-intersecting polygon.
                        NonIntersecting = FindNonIntersecting(Points);
                        e.Graphics.FillPolygon(Brushes.LightBlue,
                            NonIntersecting.ToArray());
                    }
                    else if (radAlternate.Checked)
                    {
                        e.Graphics.FillPolygon(Brushes.LightBlue,
                            Points.ToArray(), FillMode.Alternate);
                    }
                    else
                    {
                        e.Graphics.FillPolygon(Brushes.LightBlue,
                            Points.ToArray(), FillMode.Winding);
                    }

                    // Draw the original polygon's edges and vertices.
                    e.Graphics.DrawPolygon(Pens.Blue, Points.ToArray());
                    DrawPoints(e.Graphics, Points, Brushes.White, Pens.Black, null);

                    // Finish drawing the key polygon edges.
                    if (radContain.Checked)
                    {
                        // Draw the non-intersecting polygon's edges in red.
                        using (Pen pen = new Pen(Color.Red, 3))
                        {
                            e.Graphics.DrawPolygon(pen,
                                NonIntersecting.ToArray());
                        }

                        // Draw arrows on the non-intersecting polygon's edges.
                        DrawLineArrows(e.Graphics, Pens.Blue,
                            NonIntersecting, NonIntersecting.Count);

                        // Draw and number the vertices.
                        DrawPoints(e.Graphics, NonIntersecting,
                            Brushes.Yellow, Pens.Red, Brushes.Red);
                    }
                    else
                    {
                        // Draw arrows on the original polygon's edges.
                        DrawLineArrows(e.Graphics, Pens.Blue,
                            Points, Points.Count);
                    }
                } // if (Points.Count > 2)
            } // if (Drawing)
        }

        // Number the vertices.
        private void DrawPoints(Graphics gr, List<PointF> vertices,
            Brush brush, Pen pen, Brush font_brush)
        {
            using (Font font = new Font("Arial", 8))
            {
                using (StringFormat sf = new StringFormat())
                {
                    sf.Alignment = StringAlignment.Center;
                    sf.LineAlignment = StringAlignment.Center;

                    // See how big the ellipse must be.
                    float radius = 3;
                    if (font_brush != null)
                    {
                        SizeF size = gr.MeasureString((vertices.Count - 1).ToString(), font);
                        radius = Math.Max(size.Width, size.Height) / 2f;
                    }

                    // Draw the values.
                    for (int i = 0; i < vertices.Count; i++)
                    {
                        RectangleF rect = new RectangleF(
                            vertices[i].X - radius,
                            vertices[i].Y - radius,
                            2 * radius, 2 * radius);
                        gr.FillEllipse(brush, rect);
                        gr.DrawEllipse(pen, rect);
                        if (font_brush != null)
                            gr.DrawString(i.ToString(), font, font_brush, rect, sf);
                    }
                }
            }
        }

        // Draw a sequence of line arrowheads.
        private void DrawLineArrows(Graphics gr, Pen pen,
            List<PointF> points, int num_segments)
        {
            for (int i = 0; i < num_segments; i++)
            {
                int j = (i + 1) % points.Count;
                DrawArrowhead(gr, pen, points[i], points[j]);
            }
        }

        // Draw an arrowhead in the middle of the
        // line segment showing its direction.
        private void DrawArrowhead(Graphics gr, Pen pen, PointF p1, PointF p2)
        {
            float dx = p2.X - p1.X;
            float dy = p2.Y - p1.Y;
            float dist = (float)Math.Sqrt(dx * dx + dy * dy);
            dx /= dist;
            dy /= dist;
            const float scale = 4;
            dx *= scale;
            dy *= scale;
            float p1x = -dy;
            float p1y = dx;
            float p2x = dy;
            float p2y = -dx;
            float cx = (p1.X + p2.X) / 2f;
            float cy = (p1.Y + p2.Y) / 2f;
            PointF[] points =
            {
                new PointF(cx - dx + p1x, cy - dy + p1y),
                new PointF(cx, cy),
                new PointF(cx - dx + p2x, cy - dy + p2y),
            };
            gr.DrawLines(pen, points);
        }

        private void picCanvas_MouseClick(object sender, MouseEventArgs e)
        {
            // See if this is a left or right click.
            if (e.Button == MouseButtons.Left)
            {
                // Left click.
                if (!Drawing)
                {
                    // Start a new polygon.
                    Points = new List<PointF>();
                    Drawing = true;
                }

                // Add the point to the polygon.
                Points.Add(e.Location);
            }
            else
            {
                // Right click.
                Drawing = false;
                DumpPoints();
            }

            // Redraw.
            picCanvas.Refresh();
        }

        // Convert the polygon into a non-self-intersecting polygon.
        private List<PointF> FindNonIntersecting(List<PointF> vertices)
        {
            // Find the north westmost point.
            PointF to_point = NWPoint(vertices);
            PointF first_point = to_point;
            PointF second_point = new PointF(
                float.PositiveInfinity,
                float.PositiveInfinity);

            // Pretend we are coming from a
            // point directly north of to_point.
            PointF from_point = new PointF(to_point.X, to_point.Y - 10);

            // Repeat until done.
            List<PointF> result = new List<PointF>();
            for (; ; )
            {
                // Find the next segment to visit.
                PointF next_from_point, next_to_point;
                FindNextSegment(vertices, from_point, to_point,
                    out next_from_point, out next_to_point);

                // If we are about to go from start_point
                // to second_point again, then we are done.
                // (The first time we cross this edge, second_point
                // is infinite.)
                if (PointsAreClose(next_from_point, first_point) &&
                    PointsAreClose(next_to_point, second_point))
                {
                    break;
                }

                // If this is the first move, save to_point.
                if (result.Count == 0) second_point = next_to_point;

                // Move to next_from_point.
                result.Add(next_from_point);
                from_point = next_from_point;
                to_point = next_to_point;
            }
            return result;
        }

        private double Distance(PointF point1, PointF point2)
        {
            float dx = point1.X - point2.X;
            float dy = point1.Y - point2.Y;
            return Math.Sqrt(dx * dx + dy * dy);
        }

        // Return true if the two points are very close.
        private bool PointsAreClose(PointF point1, PointF point2)
        {
            return (
                (Math.Abs(point1.X - point2.X) < TINY) &&
                (Math.Abs(point1.Y - point2.Y) < TINY));
        }

        // Find the next segment that we should visit.
        // On entering:
        //      - from_point --> to_point is the segment we are crossing.
        //      - from_point may not be a vertex
        //      - to_point is a vertex
        //
        // On exit:
        //      - We should next visit the segment next_from_point --> next_to_point
        //      - next_from_point may be the same as to_point
        private void FindNextSegment(List<PointF> vertices,
            PointF from_point, PointF to_point,
            out PointF next_from_point, out PointF next_to_point)
        {
            // If this segment intersects an edge,
            // use the new segment that we find.
            if (FoundEdgeIntersection(vertices, from_point, to_point,
                out next_from_point, out next_to_point)) return;

            // This segment does not intersect an edge.
            // Find the best edge leading out of to_point.
            next_from_point = to_point;
            FindNextToPoint(vertices, from_point, to_point, out next_to_point);
            next_from_point = to_point;
        }

        // Return the index of the upper leftmost vertex.
        private PointF NWPoint(List<PointF> vertices)
        {
            PointF best_point = vertices[0];
            float best_x = best_point.X;
            float best_y = best_point.Y;
            foreach (PointF test_point in vertices)
            {
                if ((test_point.X < best_x) ||
                    ((test_point.X == best_x) && (test_point.Y < best_y)))
                {
                    best_point = test_point;
                    best_x = best_point.X;
                    best_y = best_point.Y;
                }
            }
            return best_point;
        }

        // See if the segment from_point --> to_point intersects an edge.
        // If it does:
        //      - Find the intersection closest to from_point.
        //      - Set next_from_point to the POI.
        //      - Set next_to_point to to_point.
        //
        // Return true if we find an intersection.
        private bool FoundEdgeIntersection(List<PointF> vertices,
            PointF from_point, PointF to_point,
            out PointF new_from_point, out PointF new_to_point)
        {
            // See if this segment intersects an edge.
            PointF best_poi = new PointF(float.NegativeInfinity, float.NegativeInfinity);
            PointF best_from_point = best_poi;
            PointF best_to_point = best_poi;
            double best_angle = double.PositiveInfinity;
            float best_t1 = float.PositiveInfinity;
            for (int i = 0; i < vertices.Count; i++)
            {
                int j = (i + 1) % vertices.Count;
                PointF test_from_point = vertices[i];
                PointF test_to_point = vertices[j];

                // Don't compare this segment with others
                // that share its end points
                if ((from_point == test_from_point) ||
                    (from_point == test_to_point) ||
                    (to_point == test_to_point) ||
                    (to_point == test_from_point)) continue;

                // See if they intersect.
                bool lines_intersect, segments_intersect;
                float test_t1, t2;
                PointF intersection, close_point1, close_point2;
                FindIntersection(
                    from_point, to_point,
                    test_from_point, test_to_point,
                    out lines_intersect,
                    out segments_intersect,
                    out test_t1, out t2,
                    out intersection,
                    out close_point1,
                    out close_point2);

                if (segments_intersect)
                {
                    // See if this point of intersection is closer
                    // to from_point than the previous best intersection.
                    if ((test_t1 > TINY) && (test_t1 < best_t1 + TINY))
                    {
                        // See whether we should head toward
                        // vertices[i] or vertices[j].
                        // Get the angle:
                        // from_point --> intersection --> test_to_point.
                        double test_angle = VectorAngle(
                            from_point, intersection,
                            intersection, test_to_point);
                        if (test_angle > 0)
                        {
                            // The angle is positive so it turns to the right.
                            // Head toward test_from_point (vertices[i]) instead.
                            test_angle = -test_angle;
                            test_to_point = test_from_point;
                        }

                        // If we have found this POI before, see if this
                        // angle is better than the one we had previously.
                        bool use_new_intersection = false;
                        if (test_t1 < best_t1)
                            use_new_intersection = true;
                        else if (Math.Abs(test_t1 - best_t1) < TINY)
                        {
                            if (test_angle < best_angle)
                                use_new_intersection = true;
                        }

                        // See if we should use this intersection.
                        if (use_new_intersection)
                        {
                            // Save this intersection.
                            best_poi = intersection;
                            best_from_point = intersection;
                            best_to_point = test_to_point;
                            best_angle = test_angle;
                            best_t1 = test_t1;
                        }
                    } // if (test_t1 < best_t1 + TINY)
                } // if (segments_intersect)
            } // for (int i = 0; i < vertices.Count; i++)

            // Return the best value we found.
            new_from_point = best_from_point;
            new_to_point = best_to_point;
            return !float.IsInfinity(new_from_point.X);
        }

        // We are traveling from_point --> to_point.
        // Find the next vertex that we should should visit
        // to_point --> next_to_point.
        private void FindNextToPoint(List<PointF> vertices,
            PointF from_point, PointF to_point,
            out PointF next_to_point)
        {
            int best_j = -1;
            double best_angle = double.PositiveInfinity;

            // Find to_point.
            for (int i = 0; i < vertices.Count; i++)
            {
                if (vertices[i] == to_point)
                {
                    // Consider moving from vertices[i] to
                    // vertices[i - 1] and vertices[i + 1] .
                    for (int incr = -1; incr <= 1; incr += 2)
                    {
                        int j = (i + incr + vertices.Count) % vertices.Count;
                        PointF test_to_point = vertices[j];
                        double test_angle = VectorAngle(
                            from_point, to_point,
                            to_point, test_to_point);

                        // Don't double back.
                        if (Math.Abs(test_angle - Math.PI) < 0.01)
                            test_angle = double.PositiveInfinity;
                        if (Math.Abs(test_angle - -Math.PI) < 0.01)
                            test_angle = double.PositiveInfinity;

                        // See if this angle is an improvement.
                        if (test_angle < best_angle)
                        {
                            best_j = j;
                            best_angle = test_angle;
                        }
                    }
                }
            }

            // Return the result.
            Debug.Assert(best_j >= 0);
            next_to_point = vertices[best_j];
        }

        // Find the point of intersection between
        // the lines p1 --> p2 and p3 --> p4.
        private void FindIntersection(
            PointF p1, PointF p2, PointF p3, PointF p4,
            out bool lines_intersect, out bool segments_intersect,
            out float t1, out float t2,
            out PointF intersection,
            out PointF close_p1, out PointF close_p2)
        {
            // Get the segments' parameters.
            float dx12 = p2.X - p1.X;
            float dy12 = p2.Y - p1.Y;
            float dx34 = p4.X - p3.X;
            float dy34 = p4.Y - p3.Y;

            // Solve for t1 and t2
            float denominator = (dy12 * dx34 - dx12 * dy34);

            t1 = ((p1.X - p3.X) * dy34 + (p3.Y - p1.Y) * dx34) / denominator;
            if (float.IsInfinity(t1))
            {
                // The lines are parallel (or close enough to it).
                lines_intersect = false;
                segments_intersect = false;
                intersection = new PointF(float.NaN, float.NaN);
                t1 = float.PositiveInfinity;
                t2 = float.PositiveInfinity;
                close_p1 = new PointF(float.NaN, float.NaN);
                close_p2 = new PointF(float.NaN, float.NaN);
                return;
            }
            lines_intersect = true;

            t2 = ((p3.X - p1.X) * dy12 + (p1.Y - p3.Y) * dx12) / -denominator;

            // Find the point of intersection.
            intersection = new PointF(p1.X + dx12 * t1, p1.Y + dy12 * t1);

            // The segments intersect if t1 and t2 are between 0 and 1.
            segments_intersect =
                ((t1 >= 0) && (t1 <= 1) &&
                 (t2 >= 0) && (t2 <= 1));

            // Find the closest points on the segments.
            if (t1 < 0)
            {
                t1 = 0;
            }
            else if (t1 > 1)
            {
                t1 = 1;
            }

            if (t2 < 0)
            {
                t2 = 0;
            }
            else if (t2 > 1)
            {
                t2 = 1;
            }

            close_p1 = new PointF(p1.X + dx12 * t1, p1.Y + dy12 * t1);
            close_p2 = new PointF(p3.X + dx34 * t2, p3.Y + dy34 * t2);
        }

        // Return the angle between vector p11 --> p12 and p21 --> p22.
        // Angles less than zero are to the left. Angles greater than
        // zero are to the right.
        private double VectorAngle(PointF p11, PointF p12, PointF p21, PointF p22)
        {
            // Find the vectors.
            PointF v1 = new PointF(p12.X - p11.X, p12.Y - p11.Y);
            PointF v2 = new PointF(p22.X - p21.X, p22.Y - p21.Y);

            // Calculate the vector lengths.
            double len1 = Math.Sqrt(v1.X * v1.X + v1.Y * v1.Y);
            double len2 = Math.Sqrt(v2.X * v2.X + v2.Y * v2.Y);

            // Use the dot product to get the cosine.
            double dot_product = v1.X * v2.X + v1.Y * v2.Y;
            double cos = dot_product / len1 / len2;

            // Use the cross product to get the sine.
            double cross_product = v1.X * v2.Y - v1.Y * v2.X;
            double sin = cross_product / len1 / len2;

            // Find the angle.
            double angle = Math.Acos(cos);
            if (sin < 0) angle = -angle;
            return angle;
        }

        // Display the polygon's points in the Console window.
        private void DumpPoints()
        {
            Console.WriteLine("private void MakeShape()");
            Console.WriteLine("{");
            Console.WriteLine("    Points = new List<PointF>();");
            foreach (PointF point in Points)
            {
                Console.WriteLine("    Points.Add(new PointF(" +
                    point.X.ToString() + ", " +
                    point.Y.ToString() + "));");
            }
            Console.WriteLine("    picCanvas.Refresh();");
            Console.WriteLine("}");
            Console.WriteLine("**********");
        }

        private void radShape_Click(object sender, EventArgs e)
        {
            RadioButton rad = sender as RadioButton;
            switch (rad.Text)
            {
                case "Star":
                    MakeStar();
                    break;
                case "Shape 2":
                    MakeShape2();
                    break;
                case "Shape 3":
                    MakeShape3();
                    break;
                case "Shape 4":
                    MakeShape4();
                    break;
                case "Shape 5":
                    MakeShape5();
                    break;
                case "Shape 6":
                    MakeShape6();
                    break;
                case "Shape 7":
                    MakeShape7();
                    break;
                case "Shape 8":
                    MakeShape8();
                    break;
                case "Shape 9":
                    MakeShape9();
                    break;
            }
            picCanvas.Refresh();
        }
    }
}
